<?php
namespace Teknisa\GOP\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DataSource\FilterCriteria;


class Gop10001SimulacaoValoresController extends \Teknisa\GER\Controllers\TeknisaCrud {
    
    protected $parameterBag;
    protected $util;
    protected $environment;
    protected $dataSourceName;
    protected $parameterBagColums;
    protected $dataSourceManager;
    
    public function __construct($crudService, $parameterBag, $util, $environment, $dataSourceManager){
        $this->crudService          = $crudService;
        $this->util                 = $util;
        $this->environment          = $environment;
        $this->dataSourceManager    = $dataSourceManager;
    }
   
    public function filterSimulation(DTO\Request $request, DTO\Response $response) {
        $row = $request->getRow();
        try {
            if(isset($row['NRLISTA']) && $row['NRLISTA'] != '') {
                $this->util->deleteLista($row['NRLISTA']);
            }
            $nrLista = $this->util->insertLista($row['CDFILIAL']);
            $conditions = array(
                array(
                    "columnName"=>"P_NRLISTA", 
                    "operator"=>"=", 
                    "value"=>$nrLista
                ),
                array(
                    "columnName"=>"P_IDPERIODOORCA", 
                    "operator"=>"=", 
                    "value"=>$row["P_IDPERIODOORCA"]
                ),
                array(
                    "columnName"=>"P_NRPERIODOORCA", 
                    "operator"=>"=", 
                    "value"=>$row["P_NRPERIODOORCA"]
                ),
                array(
                    "columnName"=>"P_NRANOORCAGOP", 
                    "operator"=>"=", 
                    "value"=>$row["P_NRANOORCAGOP"]
                ),
                array(
                    "columnName"=>"P_NRORG", 
                    "operator"=>"=", 
                    "value"=>$this->environment->getNrOrg()
                )
            );
            $result = $this->crudService->getFilteredDataSet('gop10001_simulacaoValores', $conditions);
            $dados = $result->getRows();
            $dataSet = array(
                "data"=>$dados,
                "nrLista"=>$nrLista
            );
            $response->addDataSet(new DataSet('success', $dataSet));
        }catch(\Exception $e){
            $response->setError(new Error($e->getMessage(), 500)); 
        }
    }
}


