<?php
namespace Teknisa\GOP\Modules\Cadastro\Controllers; 

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\Controller;
use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\Controller\Crud;
use Zeedhi\Framework\DataSource;
use Zeedhi\Framework\DTO\Response\Notification;

class Ger80700OrcamentoMoController extends \Teknisa\GER\Controllers\TeknisaCrud {
    protected $connection;
    protected $dataSourceManager;
    
    public function __construct($crudService, ParameterBag $parameterBag, $connection, $dataSourceManager) {
        $this->connection = $connection;
        $this->dataSourceManager    = $dataSourceManager;
        parent::__construct($crudService, $parameterBag);
        
    }
    
    public function excluiDespesa(DTO\Request $request, DTO\Response $response ){
        $dados = $request->getDataSet()->getRows();
        if($dados != null){
            $row = $dados[0];
            try{
                $filtro = array(
                    array(
                        "columnName" => "CDDESPADMFAT",
                        "operator" => "=",
                        "value" => $row["CDDESPADMFAT"]
                    ),
                    array(
                        "columnName" => "CDORCAMENTOMO",
                        "operator" => "=",
                        "value" => $row["CDORCAMENTOMO"]
                    )
                );
                $dataSetProd = $this->crudService->getFilteredDataSet('desporcamo', $filtro);
    		    $this->dataSourceManager->delete($dataSetProd);
                
            }catch(\Exception $ex){
                $response->setError(new Error("Nao foi possivel processar os dados enviados   --- " . $ex->getMessage(), 500));
                 
            }
            
        }
    }

    
}


